/*
 *  m_connectivity.cpp
 *
 *  Created by Kari Haugsdal
 *
 */

#include <iostream>
#include "m_connectivity.h"

void MConnectivity(SDL_Surface *original, SDL_Surface *copy) {

	pixel * originalPixels = (pixel*) original->pixels;
	pixel * copyPixels = (pixel*) copy->pixels;
		
	//The masks
	//int mask[4][3][3] = { { { 1, 0, 2 }, { 0, 0, 1 }, { 2, 1, 1 } },
	//		              { { 2, 0, 1 }, { 1, 0, 0 }, { 1, 1, 2 } },
	//		              { { 1, 1, 2 }, { 1, 0, 0 }, { 2, 0, 1 } },
	//		              { { 2, 1, 1 }, { 0, 0, 1 }, { 1, 0, 2 } }};
	
	//The masks med mer "dont care" felter
	int mask[4][3][3] = { { { 2, 0, 2 }, { 0, 0, 2 }, { 2, 2, 2 } },
			              { { 2, 0, 2 }, { 2, 0, 0 }, { 2, 2, 2 } },
			              { { 2, 2, 2 }, { 2, 0, 0 }, { 2, 0, 2 } },
			              { { 2, 2, 2 }, { 0, 0, 2 }, { 2, 0, 2 } }};

		//Looping through the filters
		for (int n = 0; n < 4; n++) {
			//Looping through the pixels
			for (int x = 1; x < original->w - 1; x++) {
				for (int y = 1; y < original->h - 1; y++) {
				
					//print trubel pixel!
					//if( x == 86 && y == 151){
						//int StartType = originalPixels[x + y * (copy->w)].r;
						//int StartB = originalPixels[x + y * (copy->w)].b;
						//int StartG = originalPixels[x + y * (copy->w)].g;
						//std::cout << "Trubel pixel:"  << std::endl;
						//std::cout << "Pixel x: " << x << " y: " << y << " B Value: " << StartB << " G Value: " << StartG << " Type: " << StartType  << std::endl;
						//std::cout << "Naboene: "  << std::endl;
					//}

					//Looping through the neighbours of the current pixel
					bool valid = true;
					for (int i = -1; i < 2; i++) {
						for (int j = -1; j < 2; j++) {
						
							//print trubel pixel naboer!
							//if( x == 86 && y == 151){
								//int StartType = originalPixels[(x + i) + (y + j) * (copy->w)].r;
								//int StartB = originalPixels[(x + i) + (y + j) * (copy->w)].b;
								//int StartG = originalPixels[(x + i) + (y + j) * (copy->w)].g;
								//int nyX = (x + i);
								//int nyY = (y + j);
								//std::cout << "Pixel x: " << nyX << " y: " << nyY << " B Value: " << StartB << " G Value: " << StartG << " Type: " << StartType  << std::endl;
							//}
						
							//The picture is grayscale so we are looking at all color channels
							int red = originalPixels[(x + i) + (y + j)* (original->w)].r;
							int green = originalPixels[(x + i) + (y + j)* (original->w)].g;
							int blue = originalPixels[(x + i) + (y + j)* (original->w)].b;
							int maskVal = mask[n][j + 1][i + 1];

							//Is this neighbour fitting the mask?
							if (!(maskVal == 2 || (maskVal == 0 && (red > 0 || blue > 0 || green > 0)) || (maskVal == 1 && red == 0 && green == 0 && blue == 0))) {
								valid = false;
								goto afterLoop;
							}
						}
						//Here be dragons! Arr!
					}
					afterLoop:

					// Did the mask fit?
					if (valid) {

						//delete pixel in the midle of the mask, chnge to black, 0
						copyPixels[x + y * (original->w)].r = 0;
						copyPixels[x + y * (original->w)].b = 0;
						copyPixels[x + y * (original->w)].g = 0;
					}
				}
			}

			
			//Ugly! The pixels we just changed should now be the original
			for (int a = 0; a < original->w; a++) {
				for (int c = 0; c < original->h; c++) {
					originalPixels[a + c * (original->w)].r = copyPixels[a + c * (original->w)].r;
					originalPixels[a + c * (original->w)].b = copyPixels[a + c * (original->w)].b;
					originalPixels[a + c * (original->w)].g = copyPixels[a + c * (original->w)].g;
				}
			}
			
		}
		
		//trubel pixel that doesnt want to be deleted!
		//std::cout << "Pixel after deleting: "<< std::endl;
		//int StartType = originalPixels[86 + 151 * (copy->w)].r;
		//int StartB = originalPixels[86 + 151 * (copy->w)].b;
		//int StartG = originalPixels[86 + 151 * (copy->w)].g;
		//originalPixels[86 + 151 * (copy->w)].r = 255;
		//originalPixels[86 + 151 * (copy->w)].b = 1;
		//originalPixels[86 + 151 * (copy->w)].g = 1;
		//int nyX = 86;
		//int nyY = 151;
		//std::cout << "Pixel x: " << nyX << " y: " << nyY << " B Value: " << StartB << " G Value: " << StartG << " Type: " << StartType  << std::endl;

}