/*
 *  tools.cpp
 *  project
 *
 *  Created by Kari Haugsdal on 06.06.10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#include "tools.h"
#include <cstdlib> //for random number
#include <iostream>

void TestColors(SDL_Surface *surface) {

	pixel * pixels = (pixel*) surface->pixels;
	
  int x;
  int y;
  for (x = 0; x < surface->w; x++) {
    for (y = 0; y < surface->h; y++) {
		//Funker		
		if (x < (surface->w/3)) {
			pixels[x + y*(surface->w)].r = 255;
			pixels[x + y*(surface->w)].g = 0;
			pixels[x + y*(surface->w)].b = 0;
			//std::cout << "Reach 1: " << std::endl;
		}
		if (x > (surface->w/3) && x < ((surface->w/3)*2)) {
			pixels[x + y*(surface->w)].r = 0;
			pixels[x + y*(surface->w)].g = 255;
			pixels[x + y*(surface->w)].b = 0;
			//std::cout << "Reach 2: " << std::endl;
		}
		else if  (x > ((surface->w/3)*2)){
			pixels[x + y*(surface->w)].r = 0;
			pixels[x + y*(surface->w)].g = 0;
			pixels[x + y*(surface->w)].b = 255;
			//std::cout << "Reach 3: " << std::endl;
		}
    }
  }
}

void MakeFrame(SDL_Surface *surface) {
	
	pixel * pixels = (pixel*) surface->pixels;

  int x;
  int y;
  for (x = 0; x < surface->w; x++) {
    for (y = 0; y < surface->h; y++) {
		
		if (x == 0 || y == 0 || x == (surface->w-1) || y == (surface->h-1)) { //Viktig, bildet er fra 0 til w-1 osv.
			
			pixels[x + y*(surface->w)].b = 0;
			pixels[x + y*(surface->w)].r = 0;
			pixels[x + y*(surface->w)].g = 0;
		}
	}
  }			
}

//Use after setting .b and .g as edge set number!
void GetRidOfSmallEdges(SDL_Surface *surface, SDL_Surface *copy, int limit) {
 
	pixel * pixels = (pixel*) surface->pixels;
	pixel * copyPixels = (pixel*) copy->pixels;
	
	for (int x = 0; x < surface->w; x++) {
		for (int y = 0; y < surface->h; y++) {
			
			if (pixels[x + y*(surface->w)].b > 0 && pixels[x + y*(surface->w)].g > 0) { //found an edge
			
				int counter = 0;
				int EdgeBValue = pixels[x + y*(surface->w)].b; 
				int EdgeGValue = pixels[x + y*(surface->w)].g;
				
				for (int i = 0; i < surface->w; i++) {
					for (int j = 0; j < surface->h; j++) {
						if(pixels[i + j*(surface->w)].b == EdgeBValue && pixels[i + j*(surface->w)].g == EdgeGValue){	//if pixel is part of the edge
						
							copyPixels[i + j*(surface->w)].r = pixels[i + j * (surface->w)].r;
							copyPixels[i + j*(surface->w)].b = pixels[i + j * (surface->w)].b;
							copyPixels[i + j*(surface->w)].g = pixels[i + j * (surface->w)].g;
							//Delete pixel from original.
							pixels[i + j * (surface->w)].r = 0;
							pixels[i + j * (surface->w)].b = 0;
							pixels[i + j * (surface->w)].g = 0;
							//increse counter
							counter++;

						}
					}
				} //second go true picture finished
				
				if(counter < limit){
					//go thru picture one more time and delete edge
					for (int i = 0; i < surface->w; i++) {
						for (int j = 0; j < surface->h; j++) {
							if(copyPixels[i + j*(surface->w)].b == EdgeBValue && copyPixels[i + j*(surface->w)].g == EdgeGValue){	//if pixel is part of the edge
								
								copyPixels[i + j*(surface->w)].r = 0;
								copyPixels[i + j*(surface->w)].b = 0;
								copyPixels[i + j*(surface->w)].g = 0;
							}
						}
					} //third go true picture finished

				}
				
			}
		}
	} //go true picture finished
	
	//Show copy picture as screen picture
	for (int x = 0; x < surface->w; x++) {
		for (int y = 0; y < surface->h; y++) {
			pixels[x + y * (surface->w)].r = copyPixels[x + y * (surface->w)].r;
			pixels[x + y * (surface->w)].b = copyPixels[x + y * (surface->w)].b;
			pixels[x + y * (surface->w)].g = copyPixels[x + y * (surface->w)].g;
		}
	}

}

//Use after setting .b and .g as edge set number!
void ColorEdges(SDL_Surface *surface, SDL_Surface *copy) {
 
	pixel * pixels = (pixel*) surface->pixels;
	pixel * copyPixels = (pixel*) copy->pixels;
;
	for (int x = 0; x < surface->w; x++) {
		for (int y = 0; y < surface->h; y++) {
			
			if (pixels[x + y*(surface->w)].b > 0 && pixels[x + y*(surface->w)].g > 0) { //found an edge
				
				int EdgeBValue = pixels[x + y*(surface->w)].b; 
				int EdgeGValue = pixels[x + y*(surface->w)].g;
				int randomR = (rand()%255)+1;
				int randomB = (rand()%255)+1;
				int randomG = (rand()%255)+1;
				
				for (int i = 0; i < surface->w; i++) {
					for (int j = 0; j < surface->h; j++) {
						if(pixels[i + j*(surface->w)].b == EdgeBValue && pixels[i + j*(surface->w)].g == EdgeGValue){	//if pixel is part of the edge
							copyPixels[i + j*(surface->w)].r = randomR;
							copyPixels[i + j*(surface->w)].b = randomB;
							copyPixels[i + j*(surface->w)].g = randomG;
							//Delete pixel from original.
							pixels[i + j * (surface->w)].r = 0;
							pixels[i + j * (surface->w)].b = 0;
							pixels[i + j * (surface->w)].g = 0;

						}
					}
				} //second go true picture finished
				
			}
		}
	} //go true picture finished
	
	//Show copy picture as screen picture
	for (int x = 0; x < surface->w; x++) {
		for (int y = 0; y < surface->h; y++) {
			pixels[x + y * (surface->w)].r = copyPixels[x + y * (surface->w)].r;
			pixels[x + y * (surface->w)].b = copyPixels[x + y * (surface->w)].b;
			pixels[x + y * (surface->w)].g = copyPixels[x + y * (surface->w)].g;
		}
	}

}

//Use after setting .b and .g as edge set number!
void UnColorEdges(SDL_Surface *surface, SDL_Surface *copy) {
 
	pixel * pixels = (pixel*) surface->pixels;
	pixel * copyPixels = (pixel*) copy->pixels;
;
	for (int x = 0; x < surface->w; x++) {
		for (int y = 0; y < surface->h; y++) {
			
			if (pixels[x + y*(surface->w)].b > 0 && pixels[x + y*(surface->w)].g > 0) { //found an edge
			
				copyPixels[x + y * (surface->w)].r = 255;
				copyPixels[x + y * (surface->w)].b = 255;
				copyPixels[x + y * (surface->w)].g = 255;
				
			}
		}
	} //go true picture finished
	
	//Show copy picture as screen picture
	for (int x = 0; x < surface->w; x++) {
		for (int y = 0; y < surface->h; y++) {
			pixels[x + y * (surface->w)].r = copyPixels[x + y * (surface->w)].r;
			pixels[x + y * (surface->w)].b = copyPixels[x + y * (surface->w)].b;
			pixels[x + y * (surface->w)].g = copyPixels[x + y * (surface->w)].g;
		}
	}

}

//Use after setting .b and .g as edge set number!
void MakeBlackWhite(SDL_Surface *surface, SDL_Surface *copy) {
 
	pixel * pixels = (pixel*) surface->pixels;
	pixel * copyPixels = (pixel*) copy->pixels;
	
	for (int x = 0; x < surface->w; x++) {
		for (int y = 0; y < surface->h; y++) {
			
			if (pixels[x + y*(surface->w)].b == 255 && pixels[x + y*(surface->w)].g == 255 && pixels[x + y*(surface->w)].r == 255) { //found white pixel			
				copyPixels[x + y * (surface->w)].r = 0;
				copyPixels[x + y * (surface->w)].b = 0;
				copyPixels[x + y * (surface->w)].g = 0;
				
			}
			
			if (pixels[x + y*(surface->w)].b < 255 && pixels[x + y*(surface->w)].g < 255 && pixels[x + y*(surface->w)].r < 255) { //found white pixel			
				copyPixels[x + y * (surface->w)].r = 255;
				copyPixels[x + y * (surface->w)].b = 255;
				copyPixels[x + y * (surface->w)].g = 255;
				
			}
		}
	} //go true picture finished
	
	//Show copy picture as screen picture
	for (int x = 0; x < surface->w; x++) {
		for (int y = 0; y < surface->h; y++) {
			pixels[x + y * (surface->w)].r = copyPixels[x + y * (surface->w)].r;
			pixels[x + y * (surface->w)].b = copyPixels[x + y * (surface->w)].b;
			pixels[x + y * (surface->w)].g = copyPixels[x + y * (surface->w)].g;
		}
	}

}

void ColorAngels(SDL_Surface *surface, SDL_Surface *copy) {

	pixel * pixels = (pixel*) surface->pixels;
	pixel * copyPixels = (pixel*) copy->pixels;
	
	for (int x = 0; x < surface->w; x++) {
		for (int y = 0; y < surface->h; y++) {
			
			if (pixels[x + y*(surface->w)].b > 0) { //found edge pixel		
				
				if(copyPixels[x + y * (surface->w)].a == 0){
					copyPixels[x + y * (surface->w)].r = 255;
					copyPixels[x + y * (surface->w)].b = 0;
					copyPixels[x + y * (surface->w)].g = 0;
				
				}else if(copyPixels[x + y * (surface->w)].a == 45){
					copyPixels[x + y * (surface->w)].r = 0;
					copyPixels[x + y * (surface->w)].b = 255;
					copyPixels[x + y * (surface->w)].g = 0;
				
				}else if(copyPixels[x + y * (surface->w)].a == 90){
					copyPixels[x + y * (surface->w)].r = 0;
					copyPixels[x + y * (surface->w)].b = 0;
					copyPixels[x + y * (surface->w)].g = 255;
				
				}else if(copyPixels[x + y * (surface->w)].a == 135){
					copyPixels[x + y * (surface->w)].r = 255;
					copyPixels[x + y * (surface->w)].b = 0;
					copyPixels[x + y * (surface->w)].g = 255;
				
				}
			}
		}
	} //go true picture finished
	
	//Show copy picture as screen picture
	for (int x = 0; x < surface->w; x++) {
		for (int y = 0; y < surface->h; y++) {
			pixels[x + y * (surface->w)].r = copyPixels[x + y * (surface->w)].r;
			pixels[x + y * (surface->w)].b = copyPixels[x + y * (surface->w)].b;
			pixels[x + y * (surface->w)].g = copyPixels[x + y * (surface->w)].g;
		}
	}

}


